package edu.fichte.pbi.prgm.cmd;

import edu.fichte.pbi.run.app.IConsole;
import edu.fichte.pbi.vm.Machine;

/**
 * The basic structure of a command in the PiBasicInterpreter
 * 
 * @author Elias Groll, Johanna Reichmann
 * @version 2.15
 */
public interface ICommand {

  /**
   * Execution of a single cmd.
   * 
   * @param machine
   *          the machine on which the cmd acts
   * @param console
   *          the console which is used by the cmd to interact with the user
   */
  public void execute(Machine machine, IConsole console);

  /**
   * Explanation of the actual- executed cmd.
   * 
   * @return explanation as String with the format "[Info]*"
   */
  public String infoMsg();
}
