package edu.fichte.pbi.prgm.cmd.control;

import edu.fichte.pbi.prgm.cmd.ICommand;
import edu.fichte.pbi.run.app.IConsole;
import edu.fichte.pbi.vm.Machine;
import edu.fichte.pbi.vm.var.Bit;
import edu.fichte.pbi.vm.var.ConglomerateVariable;

public class Return implements ICommand {

  
  public void execute(Machine machine, IConsole console) {
    Bit[] gosubs = ((ConglomerateVariable) machine.parseIVariable("W6"))
        .getBits();
    int jumpTo = machine.getProgram().getCommands().size() - 1;
    search: for (int id = gosubs.length - 1; id >= 0; id--) {
      if (gosubs[id].getValue() == 1) {
        gosubs[id].setValue(0);
        for (int i = 0; i < machine.getProgram().getCommands().size(); i++) {
          ICommand cmd = machine.getProgram().getCommands().get(i);
          if ((cmd instanceof Gosub) && (((Gosub) cmd).getId() == id)) {
            jumpTo = i;
            break search;
          }
        }
      }
    }
    machine.setExecutionIndex(jumpTo);
  }

  
  public String infoMsg() {
    return "[Info]Return to last executed gosub or to end if there is none";
  }

  
  @Override
public String toString() {
    return "RETURN";
  }
}
