package edu.fichte.pbi.prgm.cmd.control.power;

import edu.fichte.pbi.prgm.cmd.ICommand;
import edu.fichte.pbi.run.app.IConsole;
import edu.fichte.pbi.vm.Machine;

/**
 * Terminates the execution of the actual program.
 * 
 * @author Elias Groll
 * @version 2.15
 */
public class End implements ICommand {

  
  public void execute(Machine machine, IConsole console) {
    machine.setExecutionIndex(machine.getProgram().getCommands().size() - 1);
  }

  
  public String infoMsg() {
    return "[Info]Terminating execution";
  }

  
  @Override
public String toString() {
    return "END";
  }

}
