package edu.fichte.pbi.prgm.cmd.debug;

import edu.fichte.pbi.prgm.cmd.ICommand;
import edu.fichte.pbi.run.app.IConsole;
import edu.fichte.pbi.vm.Machine;

/**
 * Activates the output of additional information about the commands at runtime.
 * This is not a build-in command of the bs1.
 * 
 * @author Elias Groll
 * @version 2.15
 */
public class DeactivateAdditionalInformation implements ICommand {

  
  public void execute(Machine machine, IConsole console) {
    machine.getSettings().deactivateInfo();
    // no if because alloc is faster than check
  }

  
  public String infoMsg() {
    return "[Info]Deactivating additional information";
  }

}
