package edu.fichte.pbi.prgm.cmd.storage;

import edu.fichte.pbi.prgm.cmd.HotspotCompiledCommand;
import edu.fichte.pbi.run.app.IConsole;
import edu.fichte.pbi.vm.Machine;
import edu.fichte.pbi.vm.var.IVariable;

/**
 * Used to minimize code duplicates in commands, which do something with a location and a variable.
 * 
 * @author Elias Groll
 * @version 2.15
 */
public abstract class AccessCommand extends HotspotCompiledCommand {

  public AccessCommand(String locationString, String varString) {
    this.locationString = locationString;
    this.varString = varString;
  }

  protected final String locationString;
  protected final String varString;
  protected IVariable location;
  protected IVariable var;

  protected void initVars(Machine machine, IConsole console) {
    super.execute(machine, console);
  }

  
  @Override
public void init(Machine machine) {
    var = machine.parseIVariable(varString);
    location = machine.parseIVariable(locationString);
  }

}
