package edu.fichte.pbi.prgm.cmd;

import edu.fichte.pbi.run.app.IConsole;
import edu.fichte.pbi.vm.Machine;

/**
 * A special ICommand which is generating an executable data-structure during
 * the first run.
 * 
 * @author Elias Groll
 * @version 2.15
 */
public abstract class HotspotCompiledCommand implements ICommand {
  private boolean firstRun = true;

  
  public void execute(Machine machine, IConsole console) {
    if (firstRun) {
      init(machine);
      firstRun = false;
    }
  }

  /**
   * Initialise variables and create the executable structure.
   * 
   * @param machine
   *          needed to create the struct
   */
  protected abstract void init(Machine machine);



}
