package edu.fichte.pbi.prgm.cmd.debug;

import edu.fichte.pbi.prgm.cmd.ICommand;
import edu.fichte.pbi.run.app.IConsole;
import edu.fichte.pbi.vm.Machine;

/**
 * Activates the output of additional information about the commands at runtime.
 * This is not a build-in command of the bs1.
 * 
 * @author Elias Groll
 * @version 2.15
 */
public class ActivateAdditionalInformation implements ICommand {

  
  public void execute(Machine machine, IConsole console) {
    if (!machine.getSettings().getPrintInfo()) {
      console.printLn("[Info]Activating additional information");
      // this is a trick - normally infoMsg() wont be displayed
      machine.getSettings().activateInfo();
      // no if because alloc is faster than check
    }
  }

  
  public String infoMsg() {
    return "[Info]Activating additional information";
  }

}
