package edu.fichte.pbi.prgm.cmd.io;

import edu.fichte.pbi.prgm.cmd.HotspotCompiledCommand;
import edu.fichte.pbi.run.app.IConsole;
import edu.fichte.pbi.vm.Machine;
import edu.fichte.pbi.vm.var.IVariable;

/**
 * Input/Output Command on the BS1 which uses HotspotCompilation.
 * @author Elias Groll
 * @version 2.15
 */
public abstract class IOCommand extends HotspotCompiledCommand {

  protected final String num;

  protected IVariable pin;
  protected IVariable dir;
  private IVariable check;

  
  @Override
  public void execute(Machine machine, IConsole console) {
    super.execute(machine, console);
  }

  
  @Override
protected void init(Machine machine) {
    check = machine.parseIVariable(num);
    pin = machine.parseIVariable("PIN" + check.getValue());
    dir = machine.parseIVariable("DIR" + check.getValue());
  }

  public IOCommand(String num) {
    this.num = num;
  }

}
