package edu.fichte.pbi.prgm.cmd.loop;

import edu.fichte.pbi.prgm.cmd.ICommand;
import edu.fichte.pbi.prgm.err.runtime.NoLoopHeadRuntimeError;
import edu.fichte.pbi.run.app.IConsole;
import edu.fichte.pbi.vm.Machine;

public class Next implements ICommand {

  private For head;
  private int jumpTo;

  
  public void execute(Machine machine, IConsole console) {
    if (head == null) {
      machine.getProgram().addError(new NoLoopHeadRuntimeError());
    } else if (!reached()) {
      head.getFrom().setValue(
          head.getFrom().getValue() + head.getStep().getValue());
      jumpTo = machine.getProgram().getCommands().indexOf(head);
      machine.setExecutionIndex(jumpTo);
    }

  }

  private boolean reached() {
    if (head.isNegative()) {
      return (head.getFrom().getValue() <= head.getTo().getValue());
    } else {
      return (head.getFrom().getValue() >= head.getTo().getValue());
    }
  }

  
  public String infoMsg() {
    return "[Info]Resume execution after this NEXT at Line "
        + String.valueOf(jumpTo);
  }

  
  @Override
public String toString() {
    return "NEXT";
  }

  public void setHead(For head) {
    this.head = head;
  }

}
