package edu.fichte.pbi.prgm.cmd.storage;

import edu.fichte.pbi.prgm.war.MemOverwriteWarning;
import edu.fichte.pbi.run.app.IConsole;
import edu.fichte.pbi.vm.Machine;

/**
 * Writes a value to a location in EEPROM and stores it into a variable.
 * 
 * @author Elias Groll
 * @version 2.15
 */
public class Write extends AccessCommand {

  public Write(String locationString, String varString) {
    super(locationString, varString);
  }

  
  @Override
public void execute(Machine machine, IConsole console) {
    initVars(machine, console);
    try {
      if (machine.getEeprom().read(location.getValue()) == edu.fichte.pbi.vm.storage.EEPROM.CMD) {
        machine.getProgram().addWarning(new MemOverwriteWarning());
      }
      machine.getEeprom().write(location.getValue(), var.getValue());
    } catch (NullPointerException e) {
      // nothing to do here, machine already added an error
    }
  }

  
  public String infoMsg() {
    return "[Info]Write at \"" + locationString + "\"  and store \"" + varString + "\" in EEPROM";
  }

}
