package edu.fichte.pbi.prgm.parse.arithmetical;

/**
 * Represents a binary NAND Operator in the form of an Arithmetical Operator
 * @author Johanna Reichmann
 * @version 2.15
 */
public class BNAND extends ArithmeticalOperator {

  /**
   * Executes the calculation (&/) and stores the result in retVal.
   */
  
  @Override
protected void exec() {
    retVal.setValue(leftSide.getValue() & ~rightSide.getValue());
  }
  

  /**
   * Returns a new BNAND instance.
   * @return new BNAND instance
   */
  
  @Override
public ArithmeticalOperator create() {
    return new BNAND();
  }
}
